#ifndef __API_FRACTALS_INTERFACE_GUI_EVENTS__
#define __API_FRACTALS_INTERFACE_GUI_EVENTS__

#include <gtk/gtk.h>
#include "interface.h"

void saveImage_ev(GtkWidget *widget, gpointer data);
void saveSettings_ev(GtkWidget *widget, gpointer data);
void loadSettings_ev(GtkWidget *widget, gpointer data);
void destroy_ev(GtkWidget *widget, gpointer data);

void moveUp_ev(GtkWidget *widget, gpointer data);
void moveDown_ev(GtkWidget *widget, gpointer data);
void moveLeft_ev(GtkWidget *widget, gpointer data);
void moveRight_ev(GtkWidget *widget, gpointer data);
void moveZoomIn_ev(GtkWidget *widget, gpointer data);
void moveZoomOut_ev(GtkWidget *widget, gpointer data);

void about_ev();

void reset_ev(GtkWidget *widget, gpointer data);
void reset_zoom_ev(GtkWidget *widget, gpointer data);
void reset_move_ev(GtkWidget *widget, gpointer data);

void value_changed_evA(GtkSpinButton *spinButtonA, gpointer user_data);
void value_changed_evB(GtkSpinButton *spinButtonB, gpointer user_data);
void value_changed_evIter(GtkSpinButton *spinButtonIter, gpointer user_data);
void value_changed_evZoom(GtkSpinButton *spinButtonZoom, gpointer user_data);

void change_fractal_ev(GtkWidget *widget, gpointer data);
void color_ev(GtkWidget *widget, gpointer data);
void color_from_menu_ev(GtkWidget *widget, gpointer data);

#endif /*__API_FRACTALS_INTERFACE_GUI_EVENTS__*/
