#include "interface-gui-toolbox.h"

GtkWidget *gui_toolbox_tablezoom() {
	GtkWidget	*butZoomOut,
				*butZoomIn,
				*butZoomReset;
	GtkWidget	*boxOut,
				*boxIn,
				*boxReset;
	GtkWidget	*imgOut,
				*imgIn,
				*imgReset;

	GtkWidget	*tableZoom;



	tableZoom = gtk_table_new (1, 3, FALSE);
		butZoomOut = gtk_button_new();
			boxOut = gtk_hbox_new(FALSE, 0);
				imgOut = gtk_image_new_from_file ("imgs/minus.png");
		butZoomIn = gtk_button_new();
			boxIn = gtk_hbox_new(FALSE, 0);
				imgIn = gtk_image_new_from_file ("imgs/plus.png");
		butZoomReset = gtk_button_new();
			boxReset = gtk_hbox_new(FALSE, 0);
				imgReset = gtk_image_new_from_file ("imgs/reset.png");
	

	gtk_table_attach (GTK_TABLE (tableZoom), butZoomOut, 0, 1, 0, 1,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butZoomOut),boxOut);
			gtk_box_pack_start(GTK_BOX(boxOut),imgOut,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableZoom), butZoomIn, 2, 3, 0, 1,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butZoomIn),boxIn);
			gtk_box_pack_start(GTK_BOX(boxIn),imgIn,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableZoom), butZoomReset, 1, 2, 0, 1,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butZoomReset),boxReset);
			gtk_box_pack_start(GTK_BOX(boxReset),imgReset,FALSE,FALSE,0);

	g_signal_connect((GObject*)butZoomOut, "clicked", (GCallback)moveZoomOut_ev, NULL);
	g_signal_connect((GObject*)butZoomIn, "clicked", (GCallback)moveZoomIn_ev, NULL);
	g_signal_connect((GObject*)butZoomReset, "clicked", (GCallback)reset_zoom_ev, NULL);

	return tableZoom;
}

GtkWidget *gui_toolbox_tablemove() {
	GtkWidget	*butMoveUp,
				*butMoveLeft,
				*butMoveRight,
				*butMoveDown,
				*butMoveReset;
	GtkWidget	*boxUp,
				*boxLeft,
				*boxRight,
				*boxDown,
				*boxReset;
	GtkWidget	*imgLeft,
				*imgRight,
				*imgUp,
				*imgDown,
				*imgReset;

	GtkWidget	*tableMove;

	tableMove = gtk_table_new (3, 3, FALSE);
		butMoveUp = gtk_button_new();
			boxUp = gtk_hbox_new(FALSE, 0);
				imgUp = gtk_image_new_from_file ("imgs/up.png");
		butMoveLeft = gtk_button_new();
			boxLeft = gtk_hbox_new(FALSE, 0);
				imgLeft = gtk_image_new_from_file ("imgs/left.png");
		butMoveRight = gtk_button_new();
			boxRight = gtk_hbox_new(FALSE, 0);
				imgRight = gtk_image_new_from_file ("imgs/right.png");
		butMoveDown = gtk_button_new();
			boxDown = gtk_hbox_new(FALSE, 0);
				imgDown = gtk_image_new_from_file ("imgs/down.png");
		butMoveReset = gtk_button_new();
			boxReset = gtk_hbox_new(FALSE, 0);
				imgReset = gtk_image_new_from_file ("imgs/reset.png");



	gtk_table_attach (GTK_TABLE (tableMove), butMoveUp, 1, 2, 0, 1,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butMoveUp),boxUp);
			gtk_box_pack_start(GTK_BOX(boxUp),imgUp,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableMove), butMoveLeft, 0, 1, 1, 2,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butMoveLeft),boxLeft);
			gtk_box_pack_start(GTK_BOX(boxLeft),imgLeft,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableMove), butMoveRight, 2, 3, 1, 2,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butMoveRight),boxRight);
			gtk_box_pack_start(GTK_BOX(boxRight),imgRight,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableMove), butMoveDown, 1, 2, 2, 3,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butMoveDown),boxDown);
			gtk_box_pack_start(GTK_BOX(boxDown),imgDown,FALSE,FALSE,0);
	gtk_table_attach (GTK_TABLE (tableMove), butMoveReset, 1, 2, 1, 2,
						(GtkAttachOptions) (GTK_FILL),
						(GtkAttachOptions) (0), 0, 0);
		gtk_container_add(GTK_CONTAINER(butMoveReset),boxReset);
			gtk_box_pack_start(GTK_BOX(boxReset),imgReset,FALSE,FALSE,0);

	g_signal_connect((GObject*)butMoveUp, "clicked", (GCallback)moveUp_ev, NULL);
	g_signal_connect((GObject*)butMoveLeft, "clicked", (GCallback)moveLeft_ev, NULL);
	g_signal_connect((GObject*)butMoveRight, "clicked", (GCallback)moveRight_ev, NULL);
	g_signal_connect((GObject*)butMoveDown, "clicked", (GCallback)moveDown_ev, NULL);
	g_signal_connect((GObject*)butMoveReset, "clicked", (GCallback)reset_move_ev, NULL);

	return tableMove;
}

GtkWidget *gui_toolbox_boxbuttons() {
	GtkWidget	*buttonSavImg,
				*buttonSavSet,
				*buttonLodSet,
				*buttonReset,
				*buttonAbout,
				*buttonQuit;
	GtkWidget	*boxSavImg,
				*boxSavSet,
				*boxLodSet,
				*boxReset,
				*boxAbout,
				*boxQuit;
	GtkWidget	*imgSavImg,
				*imgSavSet,
				*imgLodSet,
				*imgReset,
				*imgAbout,
				*imgQuit;
	GtkWidget	*labelSavImg,
				*labelSavSet,
				*labelLodSet,
				*labelReset,
				*labelAbout,
				*labelQuit;

	GtkWidget	*box;

	box = gtk_vbox_new(TRUE, 5);
		buttonSavImg = gtk_button_new();
			boxSavImg = gtk_hbox_new(FALSE, 0);
				imgSavImg = gtk_image_new_from_file ("imgs/image.png");
				labelSavImg = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelSavImg)," Save _Image");}
		buttonSavSet = gtk_button_new();
			boxSavSet = gtk_hbox_new(FALSE, 0);
				imgSavSet = gtk_image_new_from_file ("imgs/ssave.png");
				labelSavSet = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelSavSet)," _Save Settings");}
		buttonLodSet = gtk_button_new();
			boxLodSet = gtk_hbox_new(FALSE, 0);
				imgLodSet = gtk_image_new_from_file ("imgs/sload.png");
				labelLodSet = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelLodSet)," _Load Settings");}
		buttonReset = gtk_button_new();
			boxReset = gtk_hbox_new(FALSE, 0);
				imgReset = gtk_image_new_from_file ("imgs/reset.png");
				labelReset = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelReset)," _Reset");}
		buttonAbout = gtk_button_new();
			boxAbout = gtk_hbox_new(FALSE, 0);
				imgAbout = gtk_image_new_from_file ("imgs/about.png");
				labelAbout = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelAbout)," _About");}
		buttonQuit = gtk_button_new();
			boxQuit = gtk_hbox_new(FALSE, 0);
				imgQuit = gtk_image_new_from_file ("imgs/quit.png");
				labelQuit = gtk_label_new(NULL);
				  {gtk_label_set_markup_with_mnemonic(GTK_LABEL(labelQuit)," _Quit");}

	gtk_box_pack_start(GTK_BOX(box), buttonSavImg, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonSavImg), boxSavImg);
			gtk_box_pack_start(GTK_BOX(boxSavImg),imgSavImg,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxSavImg),labelSavImg,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(box), buttonSavSet, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonSavSet), boxSavSet);
			gtk_box_pack_start(GTK_BOX(boxSavSet),imgSavSet,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxSavSet),labelSavSet,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(box), buttonLodSet, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonLodSet), boxLodSet);
			gtk_box_pack_start(GTK_BOX(boxLodSet),imgLodSet,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxLodSet),labelLodSet,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(box), buttonReset, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonReset), boxReset);
			gtk_box_pack_start(GTK_BOX(boxReset),imgReset,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxReset),labelReset,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(box), buttonAbout, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonAbout), boxAbout);
			gtk_box_pack_start(GTK_BOX(boxAbout),imgAbout,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxAbout),labelAbout,FALSE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(box), buttonQuit, FALSE, FALSE, 0);
		gtk_container_add(GTK_CONTAINER(buttonQuit), boxQuit);
			gtk_box_pack_start(GTK_BOX(boxQuit),imgQuit,FALSE,FALSE,0);
			gtk_box_pack_start(GTK_BOX(boxQuit),labelQuit,FALSE,FALSE,0);

	g_signal_connect((GObject*)buttonSavImg, "clicked", (GCallback)saveImage_ev, NULL);
	g_signal_connect((GObject*)buttonLodSet, "clicked", (GCallback)loadSettings_ev, NULL);
	g_signal_connect((GObject*)buttonSavSet, "clicked", (GCallback)saveSettings_ev, NULL);
	g_signal_connect((GObject*)buttonReset, "clicked", (GCallback)reset_ev, NULL);
	g_signal_connect((GObject*)buttonAbout, "clicked", (GCallback)about_ev, NULL);
	g_signal_connect((GObject*)buttonQuit, "clicked", (GCallback)destroy_ev, NULL);

	return box;
}

GtkWidget *gui_toolbox_boxparameters() {
	GtkWidget		*labelA,
				*labelB,
				*labelIter,
				*labelZoom;
	GtkAdjustment	*adjA,
				*adjB,
				*adjIter,
				*adjZoom;

	GtkWidget		*box;

	box = gtk_vbox_new(TRUE, 0);
	/*                                             pocatecni      , minimum,             maximum,    step,  page, ???*/
	adjA    = (GtkAdjustment *)gtk_adjustment_new (parameter.alpha, -5000  ,                5000, 0.00001,   0.1, 0.0);
	adjB    = (GtkAdjustment *)gtk_adjustment_new (parameter.beta , -5000  ,                5000,   0.001,   0.1, 0.0);
	adjIter = (GtkAdjustment *)gtk_adjustment_new (parameter.iters,     0  ,         10000000000,     100, 10000, 0.0);
	adjZoom = (GtkAdjustment *)gtk_adjustment_new (parameter.zoom ,     0  , 1000000000000000000,       1,    10, 0.0);

	labelA = gtk_label_new("Parameter alpha");
	  {gtk_misc_set_alignment(GTK_MISC(labelA), 0, 0);}
	spinButtonA = gtk_spin_button_new(adjA, 0, 6);
	labelB = gtk_label_new("Parameter beta");
	  {gtk_misc_set_alignment(GTK_MISC(labelB), 0, 0);}
	spinButtonB = gtk_spin_button_new(adjB, 0, 3);
	labelIter = gtk_label_new("Iterations");
	  {gtk_misc_set_alignment(GTK_MISC(labelIter), 0, 0);}
	spinButtonIter = gtk_spin_button_new(adjIter, 100, 0);
	labelZoom = gtk_label_new("Zoom");
	  {gtk_misc_set_alignment(GTK_MISC(labelZoom), 0, 0);}
	spinButtonZoom = gtk_spin_button_new(adjZoom, 0, 4);

	gtk_box_pack_start(GTK_BOX(box), labelA, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), spinButtonA, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), labelB, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), spinButtonB, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), labelIter, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), spinButtonIter, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), labelZoom, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), spinButtonZoom, FALSE, FALSE, 0);

	g_signal_connect((GObject*)spinButtonA, "value-changed", (GCallback)value_changed_evA, NULL);
	g_signal_connect((GObject*)spinButtonB, "value-changed", (GCallback)value_changed_evB, NULL);
	g_signal_connect((GObject*)spinButtonIter, "value-changed", (GCallback)value_changed_evIter, NULL);
	g_signal_connect((GObject*)spinButtonZoom, "value-changed", (GCallback)value_changed_evZoom, NULL);

	return box;
}

GtkWidget *gui_toolbox_toolbox() {
	GtkWidget	*boxParameters,
			*separator0,
			*separator1,
			*labelZ,
			*tableZ,
			*separator2,
			*labelM,
			*tableM,
			*separator3,
			*boxButons;

	GtkWidget	*box;
	
	box = gtk_vbox_new(FALSE, 0);
	
	boxParameters = gui_toolbox_boxparameters();
	separator0 = gtk_hseparator_new();
	checkColor = gtk_check_button_new_with_mnemonic("_Color");
	separator1 = gtk_hseparator_new();
	labelZ = gtk_label_new("Zoom");
	  {gtk_misc_set_alignment(GTK_MISC(labelZ), 0, 0);}
	tableZ = gui_toolbox_tablezoom();
	separator2 = gtk_hseparator_new();
	labelM = gtk_label_new("Move");
	  {gtk_misc_set_alignment(GTK_MISC(labelM), 0, 0);}
	tableM = gui_toolbox_tablemove();
	separator3 = gtk_hseparator_new();
	boxButons = gui_toolbox_boxbuttons();
	
	gtk_box_pack_start(GTK_BOX(box), boxParameters, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), separator0, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(box), checkColor, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), separator1, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(box), labelZ, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), tableZ, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), separator2, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(box), labelM, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), tableM, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(box), separator3, FALSE, FALSE, 5);
	gtk_box_pack_start(GTK_BOX(box), boxButons, FALSE, FALSE, 5);

	g_signal_connect((GObject*)checkColor, "toggled", (GCallback)color_ev, NULL);

	return box;
}
