#include <math.h>

#include "main.h"
#include "utilities.h"
#include "interface.h"
#include "fractal.h"

int main (int argc, char *argv[]){	

	GtkWidget *window;

	/*
	 *   inicializace grafickyho rozhrani
	 */	
	 
	gtk_init (&argc, &argv);

	/*
	 *   vytvoreni GUI
	 */	
	 
	window = create_interface();
	if (!window)
		return EXIT_FAILURE;
	gtk_widget_show_all(window);
	
	rgbBuffer = NULL;
	paint_start();
	rgbBuffer = (guchar*)malloc(parameter.width*parameter.height*3*sizeof(char));


	/*
	 *   nastaveni default hodnot promenych
	 */

	parameter.step = 5;
	parameter.stepZoom = 10;
	parameter.fractal = 1;
	reset(0);

	/*
	 *   spusteni celeho programu
	 */	

	gtk_main ();
	
	return 0;
}

void main_quit() {
	free(rgbBuffer);
	gtk_main_quit();
}
